package com.steerinfo.baseinfo.meterbasecalibrationtime.controller;

import com.steerinfo.baseinfo.meterbasespotinfo.model.MeterBaseSpotInfo;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbasecalibrationtime.model.MeterBaseCalibrationTime;
import com.steerinfo.baseinfo.meterbasecalibrationtime.service.IMeterBaseCalibrationTimeService;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.util.StringUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;

/**
 * MeterBaseCalibrationTime RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-06-16 02:59
 * 类描述
 * 修订历史：
 * 日期：2020-06-16
 * 作者：generator
 * 参考：
 * 描述：MeterBaseCalibrationTime RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterbasecalibrationtimes")
@Api(value = "/${api.version}/meterbasecalibrationtimes", tags = "校秤时间配置 - MeterBaseCalibrationTimeController")
public class MeterBaseCalibrationTimeController extends BaseRESTfulController {

    @Autowired
    IMeterBaseCalibrationTimeService meterBaseCalibrationTimeService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasecalibrationtime:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseCalibrationTime> list = meterBaseCalibrationTimeService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "不分页查询")
    @GetMapping(value = "/noPage")
    public RESTfulResult listall(@RequestParam HashMap parmas) {
        try {
            List<MeterBaseCalibrationTime> list = meterBaseCalibrationTimeService.queryall(parmas);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasecalibrationtime:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseCalibrationTime> list = meterBaseCalibrationTimeService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterBaseCalibrationTime对象创建")
    @ApiImplicitParam(name = "meterBaseCalibrationTime", value = "详细实体meterBaseCalibrationTime", required = true, dataType = "MeterBaseCalibrationTime")
    //@RequiresPermissions("meterbasecalibrationtime:create")
    @Transactional
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterBaseCalibrationTime model) {
        try {
            String msg = meterBaseCalibrationTimeService.checkandadd(model);
            if (msg != null && !msg.equals("")) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasecalibrationtime:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterBaseCalibrationTime meterBaseCalibrationTime = meterBaseCalibrationTimeService.getById(id);
            return success(meterBaseCalibrationTime);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterBaseCalibrationTime信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterBaseCalibrationTime", value = "详细实体meterBaseCalibrationTime", required = true, dataType = "MeterBaseCalibrationTime")
    })
    //@RequiresPermissions("meterbasecalibrationtime:update")
    @Transactional
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseCalibrationTime model) {
        try {
            String msg = meterBaseCalibrationTimeService.checkandupdate(id, model);
            if (msg != null && !msg.equals("")) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }

        return success();
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasecalibrationtime:delete")
    @PutMapping(value = "/")
    public RESTfulResult delete(@RequestBody List<MeterBaseCalibrationTime> models) {
        try {
            List<String> list = new ArrayList<String>();
            for (MeterBaseCalibrationTime model : models) {
                String id = model.getId();
                list.add(id);
            }
            List<String> ids = ListUtils.convertList(list);
            meterBaseCalibrationTimeService.delete(ids);
            return success();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "废除标识符", notes = "根据传过来的MeterBaseCalibrationTime集合信息来更新详细信息")
    @ApiImplicitParams({

            @ApiImplicitParam(name = "MeterBaseCalibrationTime", value = "详细实体MeterBaseCalibrationTime", required = true, dataType = "MeterBaseCalibrationTime")
    })
    //@RequiresPermissions("combaseinfo:update")
    @Transactional
    @PostMapping(value = "/abolish")
    public RESTfulResult abolish(@RequestBody List<MeterBaseCalibrationTime> models) {
        try {
            String msg = meterBaseCalibrationTimeService.abolish(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "启用标识符", notes = "根据传过来的MeterBaseCalibrationTime集合信息来更新详细信息")
    @Transactional
    @PostMapping(value = "/Recovery")
    public RESTfulResult recovery(@RequestBody List<MeterBaseCalibrationTime> models) {
        try {
            String msg = meterBaseCalibrationTimeService.recovery(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "新增计量点校称时间", notes = "根据MeterBaseCalibrationTime,MeterBaseSpotInfo对象创建")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "meterBaseSpotInfo", value = "详细实体meterBaseSpotInfo", required = true, dataType = "MeterBaseSpotInfo"),
            @ApiImplicitParam(name = "meterBaseCalibrationTime", value = "详细实体meterBaseCalibrationTime", required = true, dataType = "MeterBaseCalibrationTime")
    })
    @Transactional
    @PostMapping(value = "/addSpotTime")
    public RESTfulResult addSpotTime(@RequestBody MeterBaseCalibrationTime mbCalibrationTime,@RequestBody MeterBaseSpotInfo mbSpotInfo) {
        try {
            String msg = meterBaseCalibrationTimeService.checkandadd(mbCalibrationTime);
            if (msg != null && !msg.equals("")) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "按校称时间编号修改校称时间数据使用状态", notes = "根据传过来的MeterBaseCalibrationTime集合信息来更新详细信息")
    @Transactional
    @PostMapping(value = "/updateStateByPrimaryKey")
    public RESTfulResult updateStateByPrimaryKey(@RequestParam(required = true) String calTimeNo,@RequestParam(required = true) String flag) {
        try {
            String msg = meterBaseCalibrationTimeService.updateStateByPrimaryKey(calTimeNo,flag);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }


}
